package com.streambase.contrib;

import java.util.ArrayList;
import java.util.List;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.DataType;
import com.streambase.sb.client.CustomFunctionResolver;


public class VWAP {

	@CustomFunctionResolver("CalculateTradesCustomFunctionResolver0")
	public static List<Long> CalculateTrades(List<Long> historical, Long totalVolume, Long volume) {		
		ArrayList<Long> orders = new ArrayList<Long>();
		long sum = 0, order;
		for (int i = 0; i < historical.size(); i++){			
			order =(Long) volume*historical.get(i)/totalVolume; 
			sum += order;
			orders.add(order);
		}
		int index = orders.size()-1;
		orders.set(index,orders.get(index)+ volume - sum);
		return orders;	
	}

	public static CompleteDataType CalculateTradesCustomFunctionResolver0(CompleteDataType historical, 
			CompleteDataType totalVolume, CompleteDataType volume) {
		if (historical.getElementType() == CompleteDataType.forLong() 
				&& totalVolume.getDataType() == DataType.LONG 
				&& volume.getDataType() == DataType.LONG)
			return CompleteDataType.forList(CompleteDataType.forLong());
		return null;
	}

}
